//StylesNonUtilises_202f.js
// 16.03.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Des styles inutiliss sont supprims

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il faut ouvrir un document InDesign.", "Attention");
	exit();
}

// tester la version du programme
var appVers = app.version[0];
if (appVers != 4) {
	if (appVers == 5) {
		alert ("Avec InDesign CS3\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else if (appVers == 6) {
		alert ("Avec InDesign CS4\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else {
		alert ("Il ne faut utiliser ce script qu'avec InDesign CS2.", "Attention");
	}
	exit();
}

// initialiser des variables
var curDoc = app.documents[0];
var noParaStyle = curDoc.paragraphStyles[0].name;
var dfParaStyle = curDoc.paragraphStyles[1].name;
var noCharStyle = curDoc.characterStyles[0].name;
var cCtr = 0;
var pCtr = 0;

// tablir la liste des styles de paragraphes qui sont utiliss 
// comme "D'aprs" et/ou "Style suivant"
var allParaStyles = curDoc.paragraphStyles;
var allParaNames = allParaStyles.everyItem().name;
var nParaStyles = allParaStyles.length;
var inUsePNames = new Array ();
var curProps, curNameP, bas, nxt;
for (var i=1; i<nParaStyles; i++) {
	curProps = allParaStyles[i].properties;
	curNameP = curProps.name;
	try {
		bas = curProps.basedOn.name;
		if (bas != undefined && bas != dfParaStyle) {
			if (!isInArray(bas, inUsePNames)) {
				inUsePNames.push(bas);
			}
		}
	}
	catch (e) {
	}
	try {
		nxt = curProps.nextStyle.name;
		if (nxt != undefined && nxt != curNameP && nxt != dfParaStyle) {
			if (!isInArray(nxt, inUsePNames)) {
				inUsePNames.push(nxt);
			}
		}
	}
	catch (e) {
	}
}

// ajouter les styles de paragraphes qui sont utiliss dans les styles d'objets
var allObjectStyles = curDoc.objectStyles;
var nObjStyles = allObjectStyles.length;
var obj;
for (var i=0; i<nObjStyles; i++) {
	try {
		obj = allObjectStyles[i].appliedParagraphStyle.name;
		if (obj != undefined && obj != noParaStyle && obj != dfParaStyle) {
			if (!isInArray(obj, inUsePNames)) {
				inUsePNames.push(obj);
			}
		}
	}
	catch (e) {
	}
}

// puis, les noms des styles de paragraphes appliqus dans le document
var allStories = curDoc.stories;
var nStories = allStories.length;
var nStyles;
for (var i=0; i<nStories; i++) {
	allStyles = allStories[i].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = allStyles.length;
	for (var s=0; s<nStyles; s++) {
		curName = allStyles[s].name;
		if (curName != noParaStyle && curName != dfParaStyle) {
			if (!isInArray(curName, inUsePNames)) {
				inUsePNames.push(curName);
			}
		}
	}
}

// les styles de paragraphes appliqus dans des tableaux
try {
	var tabPStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = tabPStyles.length;
	for (var t=0; t<nStyles; t++) {
		curName = tabPStyles[t].name;
		if (curName != noParaStyle && curName != dfParaStyle) {
			if (!isInArray(curName, inUsePNames)) {
				inUsePNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// les styles de paragraphes appliqus dans des notes
try {
	var footPStyles = allStories.everyItem().footnotes.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = footPStyles.length;
	for (var f=0; f<nStyles; f++) {
		curName = footPStyles[f].name;
		if (curName != noParaStyle && curName != dfParaStyle) {
			if (!isInArray(curName, inUsePNames)) {
				inUsePNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// une boucle  travers les styles de paragraphes; supprimer le style courant
// s'il ne se trouve pas dans la liste "styles utiliss"
for (var i=nParaStyles-1; i>1; i--) {
	curName = allParaNames[i];
	if (!isInArray(curName, inUsePNames)) {
		try {
			curDoc.paragraphStyles[i].remove();
			pCtr++;
		}
		catch (e) {
		}
	}
}

// tablir la liste des styles de caractres qui sont utiliss comme "D'aprs"
var allCharStyles = curDoc.characterStyles;
var allCharNames = allCharStyles.everyItem().name;
var nCharStyles = allCharNames.length;
var inUseCNames = new Array ();
for (var i=1; i<nCharStyles; i++) {
	try {
		bas = allCharStyles[i].properties.basedOn.name;
		if (bas != undefined && bas != noCharStyle) {
			if (!isInArray(bas, inUseCNames)) {
				inUseCNames.push(bas);
			}
		}
	}
	catch (e) {
	}
}

// ajouter les styles de caractres qui sont utiliss comme lettrines et/ou 
// dans les styles imbriqus
// in verschachtelten Formaten verwendet werden, anhngen
var allParaStyles = curDoc.paragraphStyles;
var nParaStyles = allParaStyles.length;
var nes;
for (var d=1; d<nParaStyles; d++) {
	nes = allParaStyles[d].nestedStyles;
	nStyles = nes.length;
	for (var n=0; n<nStyles; n++) {
		curName = nes[n].appliedCharacterStyle.name;
		if (curName != noCharStyle) {
			if (!isInArray(curName, inUseCNames)) {
				inUseCNames.push(curName);
			}
		}
	}
}

// puis, les noms des styles de caractres appliqus dans le document
var allStories = curDoc.stories;
var nStories = allStories.length;
for (var i=0; i<nStories; i++) {
	allStyles = allStories[i].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = allStyles.length;
	for (var s=0; s<nStyles; s++) {
		curName = allStyles[s].name;
		if (curName != noCharStyle) {
			if (!isInArray(curName, inUseCNames)) {
				inUseCNames.push(curName);
			}
		}
	}
}

// les styles de caractres appliqus dans des tableaux
try {
	var tabCStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = tabCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curName = tabCStyles[c].name;
		if (curName != noCharStyle) {
			if (!isInArray(curName, inUseCNames)) {
				inUseCNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// les styles de caractres appliqus dans des notes
try {
	var footCStyles = allStories.everyItem().footnotes.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = footCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curName = footCStyles[c].name;
		if (curName != noCharStyle) {
			if (!isInArray(curName, inUseCNames)) {
				inUseCNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// une boucle  travers les styles de caractres; supprimer le style courant
// s'il ne se trouve pas dans la liste "styles utiliss"
for (var i=nCharStyles-1; i>0; i--) {
	curName = allCharNames[i];
	if (!isInArray(curName, inUseCNames)) {
		try {
			curDoc.characterStyles[i].remove();
			cCtr++;
		}
		catch (e) {
		}
	}
}

// informer l'utilisateur
var totCtr = pCtr + cCtr;
if (totCtr == 0) {
	alert ("Aucun style supprim.", "Termin");
}
else {
	if (totCtr == 1) {
		if (pCtr == 1) {
			alert ("Un seul style de paragraphe a t supprim.", "Termin");
		}
		else {
			alert ("Un seul style de caractres a t supprim.", "Termin");
		}
	}
	else {
		alert ("Nombre de styles supprims:  " + totCtr + "\n\nStyles de paragraphes:\t" + pCtr + "\nStyles de caractres:\t\t" + cCtr, "Termin");
	}
}

// la fonction utilise pour tester si l'lment actuel se trouve dans une liste
function isInArray(curName, curArray) {
	for (var a=0; a<curArray.length; a++) {
		if(curArray[a] == curName) {
			return true;
		}
	}
	return false;
}